/*  Pcsx2 - Pc Ps2 Emulator
 *  Copyright (C) 2002-2003  Pcsx2 Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "../CDVDisodrv.h"
#include "Rpc_services.h"

int cdSid = -1;
/////////////////////////////////////////////// 0000
void cdvdfsv2_cdinit(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
	RPC_LOG("[RPC:cdvdfsv2] sceCdInit(%s)\n",
		bin[0]==SCECdINIT ? "SCECdINIT" : bin[0]==SCECdINoD ? "SCECdINoD" : "SCECdEXIT");	//FIXME: there can be another codes
#endif
	//cdSid = client->hdr.sema_id; // i guess so ;)
	//register cdvd interrupt handler; i guess there's no need, at least for now...
	CDVDFS_init();	//init file system
	*bout=1;		//ok
}

//ENTRYPOINT
void sifcall_cdvdfsv2(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
	switch (call->rpc_number) {
	case CDVD_CDINIT:	cdvdfsv2_cdinit(call, bin, bout);	break;
	default:
#ifdef RPC_LOG
		RPC_LOG("[RPC:cdvdfsv2] <%04X> function is not implemented\n", call->rpc_number);
#endif
		*bout=0;	//failure
	}
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////// 0000
void cdvdfsvA_sceCdDiskReady(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
	RPC_LOG("[RPC:cdvdfsvA] sceCdDiskReady()\n");
#endif
	//cdSid = client->hdr.sema_id; // i guess so ;)
	*bout=2; // complete
	if (cdSid != -1) 	//linuzappz: have to talk about this

#if _SIF_PLUGIN_
		g_SifInitialize.pSignalSema(cdSid);
#else
		bSema[sema].sema.count++;
#endif


}

//ENTRYPOINT
void sifcall_cdvdfsvA(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
	switch (call->rpc_number) {
	case CDVD_DISKREADY:	cdvdfsvA_sceCdDiskReady(call, bin, bout);	break;
	default:
#ifdef RPC_LOG
		RPC_LOG("[RPC:cdvdfsvA] <%04X> function is not implemented\n", call->rpc_number);
#endif
		*bout=0;	//failure
	}
}
